<launch>

    <!-- launching Activity reco (activityreco) -->
    <node pkg="activityreco" name="activityreco" type="node" output="screen">
    </node>
    
    <!-- launching Semantic mapping (semanticmapping) -->
    <node pkg="semanticmapping" name="semanticmapping" type="node" output="screen">
        <remap from="detected_objects" to="/detected_objects"/>
    </node>
    
    <!-- launching User attention estimation (userattentionestimation) -->
    <node pkg="userattentionestimation" name="userattentionestimation" type="node" output="screen">
        <remap from="face_roi" to="/humans/faces/TEST_ID_FACE/roi"/>
    </node>
    
    <!-- launching Sound source localisation (soundsourcelocalisation) -->
    <node pkg="soundsourcelocalisation" name="soundsourcelocalisation" type="node" output="screen">
        <remap from="voice_audio" to="/humans/voices/TEST_ID_VOICE/audio"/>
    </node>
    
    <!-- launching interaction_manager (interaction_manager) -->
    <node pkg="interaction_manager" name="interaction_manager" type="node" output="screen">
    </node>
    
    <!-- launching People 3D tracker (people3dtracker) -->
    <node pkg="people3dtracker" name="people3dtracker" type="node" output="screen">
    </node>
    
    <!-- launching Speech synthesis (speechsynthesis) -->
    <node pkg="speechsynthesis" name="speechsynthesis" type="node" output="screen">
    </node>
    
    <!-- launching Fisheye (fisheye) -->
    <node pkg="fisheye" name="fisheye" type="node" output="screen">
        <remap from="image_raw" to="/camera_head/color/image_raw"/>
    </node>
    
    <!-- launching F-formation (fformation) -->
    <node pkg="fformation" name="fformation" type="node" output="screen">
        <remap from="gaze" to="/humans/interactions/gaze"/>
        <remap from="groups" to="/humans/interactions/groups"/>
    </node>
    
    <!-- launching Occupancy map (occupancymap) -->
    <node pkg="occupancymap" name="occupancymap" type="node" output="screen">
        <remap from="map_refined" to="/map_refined"/>
    </node>
    
    <!-- launching dialogue arbiter (dialoguearbiter) -->
    <node pkg="dialoguearbiter" name="dialoguearbiter" type="node" output="screen">
        <remap from="voice_speech" to="/humans/voices/TEST_ID_VOICE/speech"/>
    </node>
    
    <!-- launching hri_fullbody (hri_fullbody) -->
    <node pkg="hri_fullbody" name="hri_fullbody" type="node" output="screen">
        <remap from="image_raw" to="/camera_head/color/image_raw"/>
        <remap from="body_roi" to="/humans/bodies/TEST_ID_BODY/roi"/>
        <remap from="face_roi" to="/humans/faces/TEST_ID_FACE/roi"/>
        <remap from="body_skeleton2d" to="/humans/bodies/TEST_ID_BODY/skeleton2d"/>
    </node>
    
    <!-- launching Person re-identification (personreidentification) -->
    <node pkg="personreidentification" name="personreidentification" type="node" output="screen">
        <remap from="face_roi" to="/humans/faces/TEST_ID_FACE/roi"/>
    </node>
    
    <!-- launching ROS openpose (rosopenpose) -->
    <node pkg="rosopenpose" name="rosopenpose" type="node" output="screen">
    </node>
    
    <!-- launching User visual focus (uservisualfocus) -->
    <node pkg="uservisualfocus" name="uservisualfocus" type="node" output="screen">
        <remap from="gaze" to="/humans/interactions/gaze"/>
    </node>
    
    <!-- launching robot_behavior (robot_behavior) -->
    <node pkg="robot_behavior" name="robot_behavior" type="node" output="screen">
        <remap from="groups" to="/humans/interactions/groups"/>
    </node>
    
    <!-- launching respeaker_ros (respeaker_ros) -->
    <node pkg="respeaker_ros" name="respeaker_ros" type="respeaker_multichan_node.py" output="screen">
        <remap from="raw_audio" to="/audio/raw_audio"/>
        <remap from="ego_audio" to="/audio/ego_audio"/>
    </node>
    
    <!-- launching audio_processing (audio_processing) -->
    <node pkg="audio_processing" name="audio_processing" type="node" output="screen">
        <remap from="raw_audio" to="/audio/raw_audio"/>
        <remap from="ego_audio" to="/audio/ego_audio"/>
    </node>
    
    <!-- launching ORB SLAM (orbslam) -->
    <node pkg="orbslam" name="orbslam" type="node" output="screen">
        <remap from="image_raw" to="/camera_torso/color/image_raw"/>
        <remap from="map" to="/map"/>
    </node>
    
    <!-- launching Speaker identification (speakeridentification) -->
    <node pkg="speakeridentification" name="speakeridentification" type="node" output="screen">
        <remap from="postprocess_audio_streams" to="/audio/postprocess_audio_streams"/>
        <remap from="voice_audio" to="/humans/voices/TEST_ID_VOICE/audio"/>
    </node>
    
    <!-- launching RGB head (rgbhead) -->
    <node pkg="rgbhead" name="rgbhead" type="node" output="screen">
        <remap from="image_raw" to="/camera_head/color/image_raw"/>
    </node>
    
    <!-- launching Visual SLAM + 3D map (visualslam3dmap) -->
    <node pkg="visualslam3dmap" name="visualslam3dmap" type="node" output="screen">
        <remap from="image_torso" to="/camera_torso/color/image_torso"/>
        <remap from="image_head" to="/camera_head/color/image_head"/>
    </node>
    
    <!-- launching Non-verbal behaviours (nonverbalbehaviours) -->
    <node pkg="nonverbalbehaviours" name="nonverbalbehaviours" type="node" output="screen">
        <remap from="face_roi" to="/humans/faces/TEST_ID_FACE/roi"/>
        <remap from="voice_audio" to="/humans/voices/TEST_ID_VOICE/audio"/>
        <remap from="face_expression" to="/humans/faces/TEST_ID_FACE/expression"/>
    </node>
    
    <!-- launching plan_actions (plan_actions) -->
    <node pkg="plan_actions" name="plan_actions" type="node" output="screen">
    </node>
    
    <!-- launching Object detection/identification/localisation (objectdetectionidentificationlocalisation) -->
    <node pkg="objectdetectionidentificationlocalisation" name="objectdetectionidentificationlocalisation" type="node" output="screen">
        <remap from="image_raw" to="/camera_head/color/image_raw"/>
        <remap from="detected_objects" to="/detected_objects"/>
    </node>
    
    <!-- launching Body 2D pose (body2dpose) -->
    <node pkg="body2dpose" name="body2dpose" type="node" output="screen">
        <remap from="image_raw" to="/camera_head/color/image_raw"/>
        <remap from="body_roi" to="/humans/bodies/TEST_ID_BODY/roi"/>
        <remap from="body_skeleton2d" to="/humans/bodies/TEST_ID_BODY/skeleton2d"/>
    </node>
    
    <!-- launching google_asr (google_asr) -->
    <node pkg="google_asr" name="google_asr" type="node" output="screen">
        <remap from="postprocess_audio_streams" to="/audio/postprocess_audio_streams"/>
    </node>
    
    <!-- launching Robot functional layer (robotfunctionallayer) -->
    <node pkg="robotfunctionallayer" name="robotfunctionallayer" type="node" output="screen">
    </node>
    
    <!-- launching Person manager (personmanager) -->
    <node pkg="personmanager" name="personmanager" type="node" output="screen">
        <remap from="face_demographics" to="/humans/faces/TEST_ID_FACE/demographics"/>
        <remap from="person_face_id" to="/humans/persons/TEST_ID_PERSON/face_id"/>
        <remap from="person_demographics" to="/humans/persons/TEST_ID_PERSON/demographics"/>
        <remap from="body_id" to="/humans/persons/*/body_id"/>
        <remap from="person_voice_id" to="/humans/persons/TEST_ID_PERSON/voice_id"/>
    </node>
    
    <!-- launching Face detection (facedetection) -->
    <node pkg="facedetection" name="facedetection" type="node" output="screen">
        <remap from="image_raw" to="/camera_head/color/image_raw"/>
        <remap from="face_roi" to="/humans/faces/TEST_ID_FACE/roi"/>
    </node>
    
    <!-- launching RGB-D + camera_info (rgbdcamera_info) -->
    <node pkg="rgbdcamera_info" name="rgbdcamera_info" type="node" output="screen">
        <remap from="image_raw" to="/camera_torso/color/image_raw"/>
    </node>
    
    <!-- launching Voice speech matching (voicespeechmatching) -->
    <node pkg="voicespeechmatching" name="voicespeechmatching" type="node" output="screen">
        <remap from="speech_streams" to="/audio/speech_streams"/>
        <remap from="voice_audio" to="/humans/voices/TEST_ID_VOICE/audio"/>
        <remap from="voice_speech" to="/humans/voices/TEST_ID_VOICE/speech"/>
    </node>
    
    <!-- launching Mask detection (maskdetection) -->
    <node pkg="maskdetection" name="maskdetection" type="node" output="screen">
        <remap from="face_roi" to="/humans/faces/TEST_ID_FACE/roi"/>
        <remap from="face_mask" to="/humans/faces/TEST_ID_FACE/mask"/>
    </node>
    
    <!-- launching Depth estimation from monocular (depthestimationfrommonocular) -->
    <node pkg="depthestimationfrommonocular" name="depthestimationfrommonocular" type="node" output="screen">
    </node>
    
    <!-- launching Scene understanding (sceneunderstanding) -->
    <node pkg="sceneunderstanding" name="sceneunderstanding" type="node" output="screen">
    </node>
    
    <!-- launching Multi-people body tracker (multipeoplebodytracker) -->
    <node pkg="multipeoplebodytracker" name="multipeoplebodytracker" type="node" output="screen">
        <remap from="image_raw" to="/camera_head/color/image_raw"/>
        <remap from="body_roi" to="/humans/bodies/TEST_ID_BODY/roi"/>
    </node>
    
    <!-- launching Robot GUI (robotgui) -->
    <node pkg="robotgui" name="robotgui" type="node" output="screen">
        <remap from="voice_speech" to="/humans/voices/TEST_ID_VOICE/speech"/>
    </node>
    
    <!-- launching Soft biometrics (softbiometrics) -->
    <node pkg="softbiometrics" name="softbiometrics" type="node" output="screen">
        <remap from="face_roi" to="/humans/faces/TEST_ID_FACE/roi"/>
        <remap from="face_demographics" to="/humans/faces/TEST_ID_FACE/demographics"/>
    </node>
    

</launch>
